/* Ilustra cómo usar un vector unidimensional de caracteres, más conocido como 
   cadena de caracteres */
#include <stdio.h>
int main(void)
{
    /* Hemos separado el código en bloques (se encuentran dentro de llaves), las 
       variables en cada bloque son independientes, por eso podemos definir varias 
       variables con el mismo nombre. */

    /* Primer bloque de código */
    {
	char cadena[5] = "hola";/* Definimos un vector de 5 caracteres, que suele 
				   llamarse cadena de caracteres. Las cadenas deben
				   finalizar siempre con el carácter \0, para 
				   indicar dónde finalizan, por lo que este vector
				   que hemos definido solo puede albergar 4 caracteres.
				   Al definir la cadena mediante comillas dobles
				   el compilador se encarga de añadir el \0.  */
	printf("Primera definición\n");
	printf("%s\n", cadena);/* %s para indicar que es una cadena de caracteres,
				   recordar la s de string. printf espera la dirección 
				   de memoria RAM de la cadena de caracteres, que 
				   se puede indicar mediante &cadena[0] o quitándole 
				   el índice (cadena) e imprime hasta encontrar \0 */
    }

    /* Segundo bloque de código */
    {
	char cadena[] = "hola";/* así es mucho mejor, el compilador se encarga 
				   por nosotros de contar la longitud de la cadena. */
	printf("Segunda definición\n");
	printf("%s\n", &cadena[0]);
    }

    /* Tercer bloque de código */
    {
	char cadena[] = { 'h', 'o', 'l', 'a', '\0' };	/* y esta es la manera más 
							   pesada de definirla */
	printf("Tercera definición\n");
	printf("%s\n", cadena);
    }
    return 0;
}
